// 08.06.2021
// Katie Isard

// in sketch 
//  -- 15 neopixels on a strip
//  -- ultrasonic sensor attached --> detacting 25 cm 
//  -- arduino uno
//  -- rowDelayk capacitor (large black one from Andrew)

// jonny adding parts to my programming so that i dont have to write up up over and over again
// jonny adding a delay to see how ti picks up the bottle when approching the board


#include <FastLED.h>
 
const int trigPin = 10;
const int echoPin = 5;
 
#define NUM_LEDS 45
 
#define DATA_PIN 3 
 
// Define the array of leds
CRGB leds[NUM_LEDS];

long duration, distance;
long randomNumber;

// by adding this it has stopped the 0 cmm blink at the beginning
unsigned long currentTime;

uint8_t    hue = 0;

int rowDelay = 1;
int bottleDelay = 1000;

 
void setup(){

  Serial.begin(9600);
  FastLED.addLeds<NEOPIXEL, DATA_PIN>(leds, NUM_LEDS);
}


 
void loop()
{  checkDistance();
  if (distance <= 10) {

    delay(bottleDelay);

    randomNumber = random(3); // total amount of options
    Serial.print("random number is ");
    Serial.println(randomNumber);

  if (randomNumber == 0) {
    andrews();
    Serial.println("Andrew");
    delay(rowDelay);
    lightsOff();
  } 
  
  if (randomNumber == 1){ 
    jonny();
    Serial.println("jonny");
    delay(rowDelay);
    lightsOff();
  }
  
  if (randomNumber == 2){ 
    delay(bottleDelay);
   for (int x=0; x < 1000; x++){
      pride(); 
      FastLED.show();
    }
      lightsOff();
    
    }
  }
}

void checkDistance(){
  pinMode(trigPin, OUTPUT);
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
 
  pinMode(echoPin, INPUT);
  duration = pulseIn(echoPin, HIGH);
 
  distance = microsecondsToCentimeters(duration);
  Serial.print("the distance is ");
  Serial.print(distance);
  Serial.println("cm, "); 
}

void row1(){
  // LEDS = 40 - 45
  // red

  currentTime = millis();

  for (int currentled = 40; currentled < 45 ; currentled++) {
      leds[currentled] = CRGB(255, 0, 0);
      FastLED.show();
  }
}
void row2(){
  // LEDS = 36 - 40
  // orange

  currentTime = millis();

  for (int currentled = 36; currentled < 40    ; currentled++) {
      leds[currentled] = CRGB(255, 111,  0);
      FastLED.show();
  }
}
void row3(){
  // LEDS = 31 - 36
  // yellow

  currentTime = millis();

  for (int currentled = 31; currentled < 36 ; currentled++) {
      leds[currentled] = CRGB(255, 230, 0);
      FastLED.show();
  }
}

void row4(){
  // LEDS = 27 - 31
  // lime green

  currentTime = millis();

  for (int currentled = 27; currentled < 31 ; currentled++) {
      leds[currentled] = CRGB(55, 255, 0);
      FastLED.show();
  }
}

void row5(){   
  // LEDS = 22 - 27
  // light blue

  currentTime = millis();

  for (int currentled = 22; currentled < 27; currentled++) {
      leds[currentled] = CRGB(0, 255, 234);
      FastLED.show();
  }
}

void row6(){ 
  // LEDS = 18 - 22
  // rich blue
  
  currentTime = millis();

  for (int currentled = 18; currentled < 22 ; currentled++) {
      leds[currentled] = CRGB(0, 162, 255);
      FastLED.show();
  }
}

void row7(){  
  // LEDS = 13 - 18
  // dark blue

  currentTime = millis();

  for (int currentled = 13; currentled < 18; currentled++) {
      leds[currentled] = CRGB(0, 26, 255);
      FastLED.show();
  }
}

void row8(){ 
  // LEDS = 9 - 13
  // pruple 

  currentTime = millis();

  for (int currentled = 9; currentled < 13; currentled++) {
      leds[currentled] = CRGB(155, 0, 255);
      FastLED.show();
  }
}

void row9(){
  // LEDS = 4 - 9
  // pink
  currentTime = millis();

  for (int currentled = 4; currentled < 9; currentled++) {
      leds[currentled] = CRGB(255, 0, 251);
      FastLED.show();
  }
}

void row10(){
  // LEDS = 0 - 4
  // dark pink
    
  currentTime = millis();

  for (int currentled = 0; currentled < 4; currentled++) {
      leds[currentled] = CRGB(255, 0, 0);
      FastLED.show();
  }
}

void lightsOff(){
  currentTime = millis();

    for (int currentled = 0; currentled < 4; currentled++) {
      leds[currentled] = CRGB::Black;
      FastLED.show();
  }
    
    for (int currentled = 4; currentled < 9; currentled++) {
      leds[currentled] = CRGB::Black;
      FastLED.show();
  }

    for (int currentled = 9; currentled < 13; currentled++) {
      leds[currentled] = CRGB::Black;
      FastLED.show();
  }
    
    for (int currentled = 13; currentled < 18; currentled++) {
      leds[currentled] = CRGB::Black;
      FastLED.show();
  }

    for (int currentled = 18; currentled < 22; currentled++) {
      leds[currentled] = CRGB::Black;
      FastLED.show();
  }


    for (int currentled = 22; currentled < 27; currentled++) {
      leds[currentled] = CRGB::Black;
      FastLED.show();
  }

  
    for (int currentled = 27; currentled < 31; currentled++) {
      leds[currentled] = CRGB::Black;
      FastLED.show();
  }
  
      for (int currentled = 31; currentled < 36; currentled++) {
      leds[currentled] = CRGB::Black;
      FastLED.show();
  }
  
      for (int currentled = 36; currentled < 40; currentled++) {
      leds[currentled] = CRGB::Black;
      FastLED.show();
  }
  
      for (int currentled = 40; currentled < 45; currentled++) {
      leds[currentled] = CRGB::Black;
      FastLED.show();
  }
}



void jonny(){

        row1();
        delay(rowDelay);
        lightsOff();
        row2();
        delay(rowDelay);
        lightsOff();
        row3();
        delay(rowDelay);
        lightsOff();
        row4();
        delay(rowDelay);
        lightsOff();
        row5();
        delay(rowDelay);
        lightsOff();
        row6();
        delay(rowDelay);
        lightsOff();
        row7();
        delay(rowDelay);
        lightsOff();
        row8();
        delay(rowDelay);
        lightsOff();
        row9();
        delay(rowDelay);
        lightsOff();
        row10();
        delay(rowDelay);
        lightsOff();
         
        row1();
        delay(rowDelay);
        lightsOff();
        row2();
        delay(rowDelay);
        lightsOff();
        row3();
        delay(rowDelay);
        lightsOff();
        row4();
        delay(rowDelay);
        lightsOff();
        row5();
        delay(rowDelay);
        lightsOff();
        row6();
        delay(rowDelay);
        lightsOff();
        row7();
        delay(rowDelay);
        lightsOff();
        row8();
        delay(rowDelay);
        lightsOff();
        row9();
        delay(rowDelay);
        lightsOff();
        row10();
        delay(rowDelay);
        lightsOff();

        row1();
        delay(rowDelay);
        lightsOff();
        row2();
        delay(rowDelay);
        lightsOff();
        row3();
        delay(rowDelay);
        lightsOff();
        row4();
        delay(rowDelay);
        lightsOff();
        row5();
        delay(rowDelay);
        lightsOff();
        row6();
        delay(rowDelay);
        lightsOff();
        row7();
        delay(rowDelay);
        lightsOff();
        row8();
        delay(rowDelay);
        lightsOff();
        row9();
        delay(rowDelay);
        lightsOff();
        row10();
        delay(rowDelay);
        lightsOff();
  }

void andrews()
{

  // row1 on
  row1();
  delay(rowDelay);

     // row2 on
     row2();
     delay(rowDelay);

  // row1 off
  row1();
  delay(rowDelay);
  lightsOff();

          // row3 on
          row3();
          delay(rowDelay);

     // row2 off
     row2();
     delay(rowDelay);
     lightsOff();

              // row4 on
              row4();
              delay(rowDelay);

          // row3 off
          row3();
          delay(rowDelay);
          lightsOff();

                  // row5 on
                  row5();
                  delay(rowDelay);

              // row4 off
              row4();
              delay(rowDelay);
              lightsOff();
    
                      // row6 on
                      row6();
                      delay(rowDelay);

                   // row5 off
                  row5();
                  delay(rowDelay);
                  lightsOff();
                    
                          // row7 on
                          row7();
                          delay(rowDelay);

                      // row6 off
                      row6();
                      delay(rowDelay);
                      lightsOff();
                      
                              // row8 on
                              row8();
                              delay(rowDelay);

                          // row7 off
                          row7();
                          delay(rowDelay);      
                          lightsOff();              
                    
                                    // row9 on
                                    row9();
                                    delay(rowDelay);

                              // row8 off
                              row8();
                              delay(rowDelay);
                              lightsOff();

                                          // row10 on
                                          row10();
                                          delay(rowDelay);

                                    // row9 off
                                    row9();
                                    delay(rowDelay);
                                    lightsOff();

                                          // row10 on
                                          row10();
                                          delay(rowDelay);
                                          lightsOff();

 }


void pride() 
{
 for (int x=0; x < 1000; x++){

  static uint16_t sPseudotime = 0;
  static uint16_t sLastMillis = 0;
  static uint16_t sHue16 = 0;
 
  uint8_t sat8 = beatsin88( 87, 220, 250);
  uint8_t brightdepth = beatsin88( 341, 96, 224);
  uint16_t brightnessthetainc16 = beatsin88( 203, (25 * 256), (40 * 256));
  uint8_t msmultiplier = beatsin88(147, 23, 60);

  uint16_t hue16 = sHue16;//gHue * 256;
  uint16_t hueinc16 = beatsin88(113, 1, 3000);
  
  uint16_t ms = millis();
  uint16_t deltams = ms - sLastMillis ;
  sLastMillis  = ms;
  sPseudotime += deltams * msmultiplier;
  sHue16 += deltams * beatsin88( 400, 5,9);
  uint16_t brightnesstheta16 = sPseudotime;
  
  for( uint16_t i = 0 ; i < NUM_LEDS; i++) {
    hue16 += hueinc16;
    uint8_t hue8 = hue16 / 256;

    brightnesstheta16  += brightnessthetainc16;
    uint16_t b16 = sin16( brightnesstheta16  ) + 32768;

    uint16_t bri16 = (uint32_t)((uint32_t)b16 * (uint32_t)b16) / 65536;
    uint8_t bri8 = (uint32_t)(((uint32_t)bri16) * brightdepth) / 65536;
    bri8 += (255 - brightdepth);
    
    CRGB newcolor = CHSV( hue8, sat8, bri8);
    
    uint16_t pixelnumber = i;
    pixelnumber = (NUM_LEDS-1) - pixelnumber;
    
    nblend( leds[pixelnumber], newcolor, 64);
    }
  }
}                                        

long microsecondsToCentimeters(long microseconds)
{
  return microseconds / 29 / 2;
}
